Attribute VB_Name = "mdlGradient"

Option Explicit

Private Type GRADIENT_RECT
    UpperLeft As Long
    LowerRight As Long
End Type
Private Type TRIVERTEX
    X As Long
    Y As Long
    Red As Integer
    Green As Integer
    Blue As Integer
    Alpha As Integer
End Type

Private Declare Function GradientFillRect Lib "msimg32" Alias "GradientFill" (ByVal hDC As Long, pVertex As TRIVERTEX, ByVal dwNumVertex As Long, pMesh As GRADIENT_RECT, ByVal dwNumMesh As Long, ByVal dwMode As Long) As Long

Private Sub DecompRGB(ByVal C, R, G, B)
    B = C \ 65536
    G = (C Mod 65536) \ 256
    R = ((C Mod 65536) Mod 256)
End Sub

Private Function Synchronize(Color As Byte) As Integer
    If Color <= 127 Then
        Synchronize = 256 * Color
    Else
        Synchronize = (256 - Color) * -256
    End If
End Function

Public Sub GradientFill(Form As Form, Color1 As Long, Color2 As Long, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, Optional Model As Long = 0)
    Dim gRect As GRADIENT_RECT
    Dim vert(1) As TRIVERTEX
    Dim Red As Byte, Green As Byte, Blue As Byte
    Dim LastScaleMode As Integer
    Dim SM As Single
    LastScaleMode = Form.ScaleMode
    Select Case Form.ScaleMode
        Case vbTwips
            SM = 1
        Case vbPoints
            SM = 20
        Case vbPixels
            SM = 15
        Case vbCharacters 'Have a problem
            SM = 120
        Case vbInches
            SM = 1440
        Case vbMillimeters
            SM = 56.69
        Case vbCentimeters
            SM = 566.9
        Case Else 'vbUser
            'Enter your code here
    End Select
    X1 = X1 * SM / 15
    Y1 = Y1 * SM / 15
    X2 = X2 * SM / 15
    Y2 = Y2 * SM / 15
    Form.ScaleMode = vbPixels
    DecompRGB Color1, Red, Green, Blue
    vert(0).X = X1
    vert(0).Y = Y1
    vert(0).Red = Synchronize(Red)
    vert(0).Green = Synchronize(Green)
    vert(0).Blue = Synchronize(Blue)
    vert(0).Alpha = 0&
    DecompRGB Color2, Red, Green, Blue
    vert(1).X = X2
    vert(1).Y = Y2
    vert(1).Red = Synchronize(Red)
    vert(1).Green = Synchronize(Green)
    vert(1).Blue = Synchronize(Blue)
    vert(1).Alpha = 0&
    gRect.UpperLeft = 0
    gRect.LowerRight = 1
    GradientFillRect Form.hDC, vert(0), 2, gRect, 1, Model
    Form.ScaleMode = LastScaleMode
End Sub
